@echo off
@rem ***** Ultimate MASM32 MakeIt.bat v1.26 by Mark Jones 2005 *****
@rem   appname="My App" [name of executable, minus extension]
@rem   rsrcname=rsrc  [name of rsrc.rc file, minus extension]
@rem   console=0 for GUI app, 1=console app
@rem   polink=0 use MS LINK, 1=use POLINK
@rem   debug=1=generate debug data
@rem   debugtype=[CV|COFF|BOTH]
@rem   verbose=0 suppresses POLINK messages
@rem   dll=0 makes .exe, 1 makes.dll
@rem   run=0 does not run .exe after compilation
@rem
@rem   Pauses only on error - no waiting
@rem   .obj and .res files are deleted
@
@rem ------------------ Only edit these values ---------------------
set appname="3d frames"
set rsrcname=rsrc
set console=0
set polink=1
set debug=0
set debugtype=BOTH
set verbose=0
set dll=0
set run=1
@rem ---------------------------------------------------------------
@
@cls
set bin=\masm32\bin
set lib=\masm32\lib
set include=\masm32\include
set err=0
@
if exist %appname%.obj del %appname%.obj
if exist %appname%.exe del %appname%.exe
@
if not exist %bin%\ml.exe goto patherror
@
if %rsrcname%=="" goto skip_rc
    %bin%\rc /v %rsrcname%.rc
    if errorlevel 1 set err=1
@   echo.
    %bin%\cvtres /machine:ix86 %rsrcname%.res
    if errorlevel 1 set err=1
    set rc=%rsrcname%.res
:skip_rc
    set rc=
@
if %dll%==1 set dll=/DLL
if %dll%==0 set dll=
@
if %verbose%==1 set verbose=/VERBOSE
if %verbose%==0 set verbose=
@
if %console%==1 goto console
if %debug%==1 goto windebugver
@
:winreleasever
    %bin%\ml /c /coff /Cp %appname%.asm
    if errorlevel 1 set err=1
@   echo.
    if %polink%==1 goto polink1
    %bin%\link /SUBSYSTEM:WINDOWS %dll% /RELEASE /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@   :polink1
    echo  Linking: %appname%.obj
    echo.
    %bin%\polink /SUBSYSTEM:WINDOWS %dll% /RELEASE /VERSION:4.0 %verbose% %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@
:windebugver
    %bin%\ml /c /coff /Cp /Fm /Zi /Zd %appname%.asm
    if errorlevel 1 set err=1
@   echo.
    if %polink%==1 goto polink2
    %bin%\link /SUBSYSTEM:WINDOWS %dll% /DEBUG /DEBUGTYPE:%debugtype% /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@   :polink2
    echo  Linking: %appname%.obj
    echo.
    %bin%\polink /SUBSYSTEM:WINDOWS %dll% /DEBUG /DEBUGTYPE:%debugtype% /VERSION:4.0 %verbose% %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@
@
:console
if %debug%==1 goto consoledebugver
@
:consolereleasever
    %bin%\ml /c /coff /Cp %appname%.asm
    if errorlevel 1 set err=1
@   echo.
    if %polink%==1 goto polink3
    %bin%\link /SUBSYSTEM:CONSOLE %dll% /RELEASE /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@   :polink3
    echo  Linking: %appname%.obj
    echo.
    %bin%\polink /SUBSYSTEM:CONSOLE %dll% /RELEASE /VERSION:4.0 %verbose% %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@
:consoledebugver
    %bin%\ml /c /coff /Cp /Fm /Zi /Zd %appname%.asm
    if errorlevel 1 set err=1
@   echo.
    if %polink%==1 goto polink4
    %bin%\link /SUBSYSTEM:CONSOLE %dll% /DEBUG /DEBUGTYPE:%debugtype% /VERSION:4.0 %appname%.obj %rc%
    if errorlevel 1 set err=1
    goto finish
@   :polink4
    echo  Linking: %appname%.obj
    echo.
    %bin%\polink /SUBSYSTEM:CONSOLE %dll% /DEBUG /DEBUGTYPE:%debugtype% /VERSION:4.0 %verbose% %appname%.obj %rc%
    if errorlevel 1 set err=1
@
:finish
    if %err%==1 pause
    if exist %appname%.obj del .\*.obj
    if not %rsrcname%=="" del %rsrcname%.res
@
if %run%==0 goto end
@
:runafter
    echo * Running application *
@   echo.
    %appname%.exe
@   goto end
@
:patherror
@   echo.
    echo  ML.EXE was not found in the path - compilation terminated!
@
:end